/*
 * PPS - The Parallel Production System - Frank Lopez - pps_questions@siliconvalleyone.com
 * 
 * FILE: memory.c - memory allocation file.
 *
 * Date: 6-16-87
 *
 */

#include <stdio.h>
#include "common.h"


/*
 *MemAlloc
 */
char *MemAlloc(size)
int size;
{
    char *new;
    extern char *malloc();

    if ((new = malloc(size)) == NULL) {

	printf("NO MORE DYNAMIC MEMORY SPACE FOR SYSTEM: \n");

	if (imgr.fn == NULL) {
	    printf("Current environment being saved.\n");	
	    SaveFile("environment");
	    }
		
	printf("System Exit.\n");
	exit(1);

	} /*OUT OF SPACE*/

    return(new);

} /*MemAlloc*/
	    	
/*
 *All of the functions listed below with function names that begin with 
 *"Return" are responsible for the returning of allocated memory to the
 *system.
 */
ReturnActivations(ptr)
struct activation *ptr;
{
    struct activation *ptemp;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	ReturnAct(ptemp);
	} /*while*/

} /*ReturnActivations*/

ReturnAct(ptr)
struct activation *ptr;
{

    ReturnValues(ptr->variables);
    free(ptr);

} /*ReturnAct*/

ReturnRuleSlot(ptr)
struct ruleslot *ptr;
{
    struct ruleslot *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	free(ptemp);
	} /*while*/

} /*ReturnRuleSlot*/

/*
 *ReturnElements - free element structures
 */
ReturnElements(ptr)
struct element *ptr;
{
    struct element *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	free(ptemp);
	} /*while*/

} /*ReturnElements*/

ReturnMatch(ptr)
struct match *ptr;
{
    struct match *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	free(ptemp);
	} /*while*/

} /*ReturnMatch*/

ReturnValues(ptr)
struct values *ptr;
{
    struct values *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	free(ptemp);
	} /*while*/

} /*ReturnValues*/

ReturnNode(ptr)
struct node *ptr;
{
    struct node *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	free(ptemp);
	} /*while*/

} /*ReturnNodes*/

FreeLr(plr)
struct lr *plr;
{
    ReturnValues(plr->locals);
    free(plr);
} /*FreeLr*/

ReturnLrs(ptr)
struct lr *ptr;
{
    struct lr *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	FreeLr(ptemp);
	} /*while*/

    return(NULL);

} /*ReturnLr*/
