/*
 *fact.c - fact related functions.
 */

#include <parallel.h>
#include <stdio.h>
#include "common.h"
#include "comm.h"

/*
 *RemoveFact - removes a fact from the fact list.
 */
RemoveFact(rs, fact)
struct defrs *rs;
struct fact *fact;
{

    if (fact == rs->factlist) {

	rs->factlist = rs->factlist->next;

	if (rs->factlist != NULL)
	    rs->factlist->prev = NULL;
	} /*if*/
    else {
	if (fact->next != NULL) 
	    fact->next->prev = fact->prev;

	fact->prev->next = fact->next;
	} /*else*/
	    
    ReturnElements(fact->entry);

    FREEMEM(fact);

 } /*For each command*/

/*
 *AddFacts - Add a new Deffacts statement to the db.
 *      cond -> 0 : Add deffacts statement to its structure.
 *	cond -> 1 : Add the name to the list of known deffact statements.
 *      cond -> 2 : Add the parsed facts to the deffacts structure.
 */
AddFacts(cond, name, stmt, facts)
int cond;
char *name; 
char *stmt; 
char **facts;
{
    struct deffacts *newfacts;

    newfacts=imgr.current_eo->deffacts;

    for (; newfacts != NULL; newfacts = newfacts->next)
	if (newfacts->name == name) {
	    if (cond != 1)
		break;

	    sprintf(error_sb, "Deffact %s redeclared.", name);
	    EH(NULLSCANNER, error_sb);
	    return(NO);
	    } /*if*/
    
    switch (cond) {
	case 0 : /*add stmt*/
		newfacts->stmt = MemAlloc(strlen(stmt) + 1);
		strcpy(newfacts->stmt, stmt);
		break;

	case 1 : /*add name*/
		newfacts = allocatestruct(deffacts);
		newfacts->name = name;
		newfacts->next = imgr.current_eo->deffacts;
		imgr.current_eo->deffacts = newfacts;
		break;

	case 2 : /*add parsed facts*/
		newfacts->facts = facts;
		break;
	} /*switch*/

    return(YES);

} /*AddFacts*/

/*
 *FactExists - does a fact exist in the factlist.
 */
FactExists(rs, fact)
struct defrs *rs;
struct element *fact;
{
    struct fact *pfacttmp;

    for (pfacttmp=rs->factlist; pfacttmp != NULL; pfacttmp=pfacttmp->next)
	if (Equal(fact, pfacttmp->entry) == YES)
	    return( YES );

    return( NO );

} /*FactExists*/

/*
 *GetFact
 */
struct fact *GetFact(rs, fact_id)
struct defrs *rs;
int fact_id;
{
    struct fact *trav;

    for (trav = rs->factlist; trav != NULL; trav = trav->next)
	if (trav->id == fact_id)
	    break;

    return(trav);

} /*GetFact*/
