/*
 *memory.c - memory allocation file.
 */

#include <parallel.h>
#include <stdio.h>
#include "common.h"

/*
 *BufSize
 */
int BufSize(buffer)
char **buffer;
{
    int ct = 0;

    for (;*buffer != NULL; ++buffer, ++ct);

    return(ct);

} /*BufSize*/

/*
 *MemAlloc
 */
char *MemAlloc(size)
int size;
{
    char *new;

    if ((new = MALLOCMEM(size)) == NULL) {

	printf("NO MORE DYNAMIC MEMORY SPACE FOR SYSTEM: \n");

	printf("System Exit.\n");
	exit(1);

	} /*OUT OF SPACE*/

    return(new);

} /*MemAlloc*/
	    	
/*
 *All of the functions listed below with function names that begin with 
 *"Return" are responsible for the returning of allocated memory to the
 *system.
 */
ReturnActivations(ptr)
struct activation *ptr;
{
    struct activation *ptemp;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	ReturnAct(ptemp);
	} /*while*/

} /*ReturnActivations*/

ReturnAct(ptr)
struct activation *ptr;
{

    ReturnValues(ptr->variables);
    FREEMEM(ptr);

} /*ReturnAct*/

ReturnRuleSlot(ptr)
struct ruleslot *ptr;
{
    struct ruleslot *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	FREEMEM(ptemp);
	} /*while*/

} /*ReturnRuleSlot*/

/*
 *ReturnElements - FREEMEM element structures
 */
ReturnElements(ptr)
struct element *ptr;
{
    struct element *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	FREEMEM(ptemp);
	} /*while*/

} /*ReturnElements*/

ReturnMatch(ptr)
struct match *ptr;
{
    struct match *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	FREEMEM(ptemp);
	} /*while*/

} /*ReturnMatch*/

ReturnValues(ptr)
struct values *ptr;
{
    struct values *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	FREEMEM(ptemp);
	} /*while*/

} /*ReturnValues*/

ReturnNode(ptr)
struct node *ptr;
{
    struct node *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	FREEMEM(ptemp);
	} /*while*/

} /*ReturnNodes*/

/*
 *FreeLr
 */
FreeLr(plr)
struct lr *plr;
{
    ReturnValues(plr->locals);
    FREEMEM(plr);
} /*FreeLr*/

ReturnLrs(ptr)
struct lr *ptr;
{
    struct lr *ptemp;

    ptemp = ptr;

    while (ptr != NULL) {
	ptemp = ptr;
	ptr = ptr->next;
	FreeLr(ptemp);
	} /*while*/

    return(NULL);

} /*ReturnLr*/
